-- In case you want to ever use Silver as a bot...
-- ...why would you?

-- FIXME: for some reason throwing angle is sometimes unaccruate. This is not a priority, but should be looked onto at some point.

local function seekEnemy(bot, allowboss)
	local ogangle = bot.mo.angle
	local mo = bot.mo
	allowboss = $ or 0

	local tbl = silv_getTKtable()
	for k,v in ipairs(tbl)
		mo.angle = ogangle
		if v.silv_grabbed continue end
		if v.type == MT_PLAYER continue end
		if v.flags & MF_MONITOR continue end
		if not (allowboss) and v.flags & MF_BOSS continue end
		if not #mo.silv_telekinesis and not (v.flags & (MF_ENEMY|MF_MISSILE)) continue end
		if #mo.silv_telekinesis and not (v.flags & MF_SHOOTABLE) and not (v.flags & (MF_ENEMY|MF_BOSS)) continue end

		mo.angle = R_PointToAngle2(mo.x, mo.y, v.x, v.y)
		if not ((R_PointToDist2(mo.x, mo.y, v.x, v.y) <= 512*mo.scale and P_CheckSight(mo, v)) or (v.flags & MF_BOSS and P_CheckSight(mo, v))) continue end

		mo.target = v
		mo.tracer = v	-- object is close, try
		mo.angle = R_PointToAngle2(mo.x, mo.y, v.x, v.y)	-- aim horizontally...
		bot.aiming = R_PointToAngle2(0, mo.z, R_PointToDist2(mo.x, mo.y, v.x, v.y), v.z)	-- aim vertically
		return true
	end
	return false
end

addHook("BotTiccmd", function(p, cmd)
	if p.mo and p.mo.skin == "silver"
		local mo = p.mo
		local previoustgt = mo.target
		if mo.silv_energy > SILVER_MAX_ENERGY/5 and not p.powers[pw_flashing]
			if not #mo.silv_telekinesis
				if seekEnemy(p)				-- we have enemies in range woo.
					if not mo.silv_delay		-- no need to use if we're on cool down lol
					and leveltime%2
						cmd.buttons = $|BT_USE	-- press spin
					end
				end
			else
				if seekEnemy(p, MF_BOSS)			-- we have enemies in range woo.
					if not mo.silv_delay			-- no need to use if we're on cool down lol
					and leveltime%2
						mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)	-- aim horizontally...
						p.aiming = R_PointToAngle2(0, mo.z, R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y), mo.target.z)	-- aim vertically
						cmd.buttons = $|BT_USE		-- press spin
					end
				end
			end
		end
	end
end)